unit UCompiler;

interface

const
  ReservedWords: array[0..18] of string = ('DIV', 'MOD', 'OR', 'OF', 'THEN', 'DO', 
    'END', 'ELSE', 'ELSIF', 'IF', 'WHILE', 'ARRAY', 'RECORD', 'CONST', 'TYPE',
    'VAR', 'PROCEDURE', 'BEGIN', 'MODULE');
    
type
  TScannerElementType = (etReservedWord, etString, etIdentifier, erNumber);
  
  TScannerElement = record
    ElementType: TScannerElementType;
    Text: string;
  end;

  TScannerElementList = array of TScannerElement;
  
  TScanner = record
    function Process(Text: string): TScannerElementList;
  end;

  TCompiler = record
  private
    procedure ExpectBlock;
    procedure ExpectReservedWord;
    procedure ExpectCommand;
  public
    SourceCode: string;
    procedure Compile;
  end;

var
  Compiler: TCompiler;

implementation

procedure TCompiler.Compile;
begin
  ExpectBlock;
end;

procedure TCompiler.ExpectBlock;
begin
//  ExpectReservedWord('begin');
  ExpectCommand;
//  ExpectReservedWord('end');
end;

procedure TCompiler.ExpectCommand;
begin
  
end;

procedure TCompiler.ExpectReservedWord;
begin
  
end;

{ TScanner }

function TScanner.Process(Text: string): TScannerElementList;
begin

end;

end.
