unit UMainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    TreeView1: TTreeView;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RichEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    SourceCode: TStrings;
  end;

var
  Form1: TForm1;

implementation

uses
  USyntaxHighLight;

{$R *.dfm}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  StringList: TStringList;
begin
  with TStringList.Create do try
    Assign(RichEdit1.Lines);
    SaveToFile('Example.pas');
  finally
    Free;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  try
    RichEdit1.Lines.LoadFromFile('Example.pas');
    ProcessHighlight(RichEdit1);
  except
  end;
end;

procedure TForm1.RichEdit1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ProcessHighlight(RichEdit1);
end;

end.
